//
//  main.cpp
//  Lab#9_3
//
//  Created by Tammy on 4/21/15.
//  Copyright (c) 2015 Tammy. All rights reserved.
//

#include <iostream>
#include <cstdlib>
#include <ctime>
using namespace std;

// define a restaurant structure with five fields and a member function
struct restaurant{
    char name;
    int open;
    int close;
    int price;
    bool chosen;
    bool status (int time);
};
// the member function of restaurant, will return whether the restaurant is available
bool restaurant::status(int time){
    // if the restaurant hasn't been chosen
    if(chosen == false){
        // the simplest case
        if(time>=open && time<=close){
            return true;
        }
        // if the business hours of the restaurant accross two days, and the entered time is in the first day
        else if(time>=open && close<open){
            return true;
        }
        // if the business hours of the restaurant accross two days, and the entered time is in the second day
        else if(time<=close && close<open){
            return true;
        }
        else{
            return false;
        }
    }
    else
        return false;
}

int main() {
    // initialization
    restaurant resArray[5];
    resArray[0] = {'A',5,12,35,false};
    resArray[1] = {'B',12,22,70,false};
    resArray[2] = {'C',11,18,300,false};
    resArray[3] = {'D',14,24,150,false};
    resArray[4] = {'E',21,04,20,false};
    
    // random the time
    srand(time(0));
    int time = (rand()%24)+1;
    cout << time << endl;
    
    // count how many restaurants are available
    int counter = 0;
    for(int i=0; i<5; i++){
        if(resArray[i].status(time)){
            counter++;
        }
    }
    // if there is no option then the program will terminate
    while(counter>0){
        // record the best choice, find the cheapest one among all available restaurant(s)
        int bestChoice[2] = {0,1000};
        for(int j=0; j<5; j++){
            if(resArray[j].status(time) && resArray[j].price<bestChoice[1]){
                bestChoice[0] = j;
                bestChoice[1] = resArray[j].price;
            }
        }
        // mark the restaurant
        resArray[bestChoice[0]].chosen = true;
        // print out the result
        cout << resArray[bestChoice[0]].name << " " << bestChoice[1] << endl;
        
        // random another time and count how many restaurants are available
        time = (rand()%24)+1;
        cout << time << endl;
        counter = 0;
        for(int i=0; i<5; i++){
            if(resArray[i].status(time)){
                counter++;
            }
        }
    }
    return 0;
}